#pragma once
#include "panel.hpp"
#include "levelmanager.hpp"
#include <SFML/Graphics/RenderWindow.hpp>
#include <SFML/Graphics/RectangleShape.hpp>
#include <SFML/Graphics/Font.hpp>
#include <SFML/Graphics/Text.hpp>
#include "lel.hpp"

namespace gui {
  class CombatUI {
    public:
      std::string $grid =
        "[*%(100,150)button_attack1 | *%(100,150)button_attack2 | *%(100,150)button_attack3 | *%(100,150)button_heal]"
        "[*%.(200,50)bar_hp | _ | %.(100,50)bar_ap ]";
      lel::Parser $layout;
      GameLevel $level;
      sf::Font $font;
      sf::RectangleShape $background;
      std::unordered_map<std::string, sf::RectangleShape> $shapes;
      std::unordered_map<std::string, sf::RectangleShape> $label_boxes;
      std::vector<sf::Text> $labels;
      CombatUI(GameLevel level);

      void render();
      void draw(sf::RenderWindow& window);
      void update_level(GameLevel &level) { $level = level; }
      void click(int x, int y);
  };
}
